#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_GiantSharkImmediateDecapitation.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_GiantSharkImmediateDecapitation> Fish_GiantSharkImmediateDecapitation::msSingleton(nullptr);

int Fish_GiantSharkImmediateDecapitation::GetCount()
{
	return (int)mMapData.size();
}

const Fish_GiantSharkImmediateDecapitationData* Fish_GiantSharkImmediateDecapitation::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_GiantSharkImmediateDecapitationData>& Fish_GiantSharkImmediateDecapitation::GetMapData()
{
	return mMapData;
}

void Fish_GiantSharkImmediateDecapitation::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_GiantSharkImmediateDecapitation::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_GiantSharkImmediateDecapitationData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mMinimumIntegral = element->IntAttribute("MinimumIntegral");
		data.mMaximumIntegral = element->IntAttribute("MaximumIntegral");
		data.mDismantlingWeight = element->IntAttribute("DismantlingWeight");
		data.mLeopardWeight = element->IntAttribute("LeopardWeight");
		data.mGold = element->IntAttribute("Gold");
		data.mAdditionalRewards = element->IntAttribute("AdditionalRewards");
		data.mRewardCard = element->IntAttribute("RewardCard");
		data.mDisplayCardType = element->Attribute("DisplayCardType");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_GiantSharkImmediateDecapitation::Load()
{
	Load("../Config/Fish_GiantSharkImmediateDecapitation.xml");
}

Fish_GiantSharkImmediateDecapitation* Fish_GiantSharkImmediateDecapitation::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_GiantSharkImmediateDecapitation());
	}
	return msSingleton.get();
}
